#include "common.h"

int g_resolution = 144;//dpi
char iniFile[MAX_PATH];
HANDLE g_hModule;
int g_isUseTemp = 0;
void loadConfig()
{
	llog("loadConfig");
	GetModuleFileName((HMODULE)g_hModule, iniFile, MAX_PATH);
	strcpy(iniFile+strlen(iniFile)-4, ".ini");
	g_resolution = GetPrivateProfileInt("Setting", "DPI", g_resolution, iniFile);
}
int getPasswordSuggest(int num, char *buf, int len)
{
	if (num < 0) num = -num;
	char key[64];
	sprintf(key, "PASS%d", num);
	GetPrivateProfileString("Password", key, "", buf, len, iniFile);
	return num+1;
}

//hLocalNULLnbuf_sizeɃt@CTCYԂĂ
int GetBitmapToMemory(HLOCAL *hLocal, unsigned long *buf_size, pdf_xref *xref, pdf_page *page, int resolution)
{
	fz_display_list *list;
	fz_device *dev;
	fz_colorspace *colorspace = fz_device_rgb;

	float zoom;
	fz_matrix ctm;
	fz_bbox bbox;
	fz_pixmap *pix;
	fz_glyph_cache_s *glyphcache;

	zoom = (float)resolution / 72;
	ctm = fz_translate(0, -page->mediabox.y1);
	ctm = fz_concat(ctm, fz_scale(zoom, -zoom));
	ctm = fz_concat(ctm, fz_rotate(page->rotate));
	bbox = fz_round_rect(fz_transform_rect(ctm, page->mediabox));

	pix = fz_new_pixmap_with_rect(colorspace, bbox);
	fz_clear_pixmap_with_color(pix, 255);

	glyphcache = fz_new_glyph_cache();
	dev = fz_new_draw_device(glyphcache, pix);
	pdf_run_page(xref, page, dev, ctm);
	fz_free_device(dev);
	fz_free_glyph_cache(glyphcache);

	BITMAPFILEHEADER fileHeader;
	BITMAPINFOHEADER infoHeader;
	unsigned long bitLength, bitWidth;
	if ((pix->w*3) % 4 == 0) {
		bitLength = pix->w*3;
	} else {
		bitLength = pix->w*3 + (4-(pix->w*3)%4);
	}
	fileHeader.bfType = 'M'*256+'B';
	fileHeader.bfSize = sizeof(fileHeader)+sizeof(infoHeader)+bitLength*pix->h;
	fileHeader.bfOffBits = sizeof(fileHeader)+sizeof(infoHeader);
	fileHeader.bfReserved1 = 0;
	fileHeader.bfReserved2 = 0;
	infoHeader.biSize = 40;
	infoHeader.biWidth = pix->w;
	infoHeader.biHeight = pix->h;
	infoHeader.biPlanes = 1;
	infoHeader.biBitCount = 24;
	infoHeader.biCompression = 0;
	infoHeader.biSizeImage = bitLength*pix->h;
	infoHeader.biClrUsed = 0;
	infoHeader.biClrImportant = 0;

	*buf_size = fileHeader.bfSize;
	if (hLocal == NULL) {	//filesize̎擾
		return 0;
	}
	*hLocal = LocalAlloc(LMEM_FIXED, *buf_size);
	if (*hLocal == NULL) {
		return SPI_NO_MEMORY;
	}
	unsigned char *buf = (unsigned char *)*hLocal;
	memcpy(buf, &fileHeader, sizeof(fileHeader));
	buf += sizeof(fileHeader);
	memcpy(buf, &infoHeader, sizeof(infoHeader));
	buf += sizeof(infoHeader);

	unsigned char *ps = pix->samples;
	for (int i=0;i<pix->h;i++) {
		unsigned char *pd = buf + (pix->h-i-1)*bitLength;
		for (int j=0;j<pix->w;j++) {
			*(pd++) = *(ps++);
			*(pd++) = *(ps++);
			*(pd++) = *(ps++);
			ps++;
		}
	}

	fz_drop_pixmap(pix);

	return 0;
}
int openPdf(pdf_xref **xref, const char *filename)
{
	fz_error error = pdf_open_xref(xref, filename, NULL);
	if (error) { return SPI_FILE_READ_ERROR;}
	if (pdf_needs_password(*xref)) {
		llog("NeedPassword");
		int num=0;
		char pass[PASS_LENGTH];
		while (1) {
			num = getPasswordSuggest(num, pass, PASS_LENGTH);
			if (pass[0] == '\0') break;
			if (pdf_authenticate_password(*xref, pass)) {
				llog("Password OK");
				break;
			}
		}
		if (pass[0] == '\0') {
			pdf_free_xref(*xref);
			return SPI_FILE_READ_ERROR;
		}
	}
	error = pdf_load_page_tree(*xref);
	if (error) { 
		pdf_free_xref(*xref);
		return SPI_FILE_READ_ERROR;
	}
	return SPI_ALL_RIGHT;
}
#ifdef MY_COMMON_DEBUG
void llog(char *s) { FILE *fp=fopen("r:/output.log", "a");fprintf(fp,"%s\n",s);fclose(fp);}
#endif
